`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 11/13/2023 08:31:42 PM
// Design Name: 
// Module Name: register
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////

module register_test();

	// Inputs
	reg clk;
	reg rst;
	reg [15:0] in;
	reg we;
	reg oe;

	// Outputs
	wire [15:0] out;

	// Instantiate the Unit Under Test (UUT)
	register uut (
		.clk(clk), 
		.rst(rst), 
		.in(in), 
		.out(out), 
		.we(we), 
		.oe(oe)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		rst = 1;
		in = 0;
		we = 0;
		oe = 0;

		// Wait 100 ns for global reset to finish
		#100;
        rst = 0;
		
        @(posedge clk) we = 1; in = 16'hA3CB; 
        @(posedge clk) we = 0; in = 16'h0; 
        @(posedge clk) oe = 1; in = 16'h0; 
        @(negedge clk) oe = 0; in = 16'h0; 
        @(posedge clk) oe = 1; in = 16'h0; 
        @(posedge clk) oe = 0; in = 16'h0; 
        @(posedge clk) we = 0; in = 16'h1234; 
        @(posedge clk) oe = 1; in = 16'h0; 
        @(posedge clk) we = 0; in = 16'h5678; oe = 0;
        @(posedge clk) oe = 1; in = 16'h0; 
        @(posedge clk) we = 1; in = 16'hABCD; oe = 0;
        @(posedge clk) oe = 1; in = 16'h0; we = 0;
        @(posedge clk) oe = 0; in = 16'h0; 
        
        #10;
	end
      
    always #10 clk = !clk;
endmodule